---

# See README.md for this pipeline for full usage instructions

# This pipeline can be called by calling the main "gitlab-ci.yml" in this repo, or called directly.
# When called directly, only sanity checks, linting, and the ancillary configuration steps are performed.
# When called directly, this pipeline depends on "ansible-ci-configure-base.yml" to be included as well.

# This code can be activated once all our Gitlab instances are at v14.8+
# Until then, downstream repos using this pipeline must add this include to their repo.
# include:  # support for nested repeated includes added in Gitlab 14.8
#   - remote: https://gitlab.com/dreamer-labs/tsc/pipelines/-/raw/master/ansible/${version}/gitlab-ci-configure-base.yml
# Where "${version}" is the pipeline version directory name

# This list should be overridden in downstream pipeline's ".gitlab-ci.yml", but should include all these stages.
# The downstream pipeline maintainer should consolidate all stages from all included pipelines into a single list.
# These are just here for reference purposes only.
stages:
  - dl-sanity-checks-stage
  - dl-lint-stage
  - dl-configure-settings-stage

variables:
  DL_ANSIBLE_DEPLOYMENT_DIR: ansible

### Jobs ###

# Used to configure day-two application configurations to staging infra via ansible
# The playbook called via this job should contain frequently run lower-risk configs
dl_ansible_configure_settings_staging:
  stage: configure_settings
  extends:
    - .dl_ansible_configure_base
  variables:
    DL_ANSIBLE_ANSIBLE_PLAYBOOK: playbooks/configure-settings.yml
  tags:
    - c1d-staging
  only:
    refs:
      - branches
    variables:
      - $DL_ANSIBLE_DEPLOYMENT_TYPE == "configure-settings" && $DL_DEPLOYMENT =~ /^staging-.*/
      - $DL_ANSIBLE_DEPLOYMENT_TYPE == "configure-system" && $DL_DEPLOYMENT =~ /^staging-.*/

# Used to configure day-two application configurations to production infra via ansible
# The playbook called via this job should contain frequently run lower-risk configs
dl_ansible_configure_settings_prod:
  stage: configure_settings
  extends:
    - .dl_ansible_configure_base
  variables:
    DL_ANSIBLE_ANSIBLE_PLAYBOOK: playbooks/configure-settings.yml
  tags:
    - c1d-prod
  only:
    refs:
      - branches
    variables:
      - $DL_ANSIBLE_DEPLOYMENT_TYPE == "configure-settings" && $DL_DEPLOYMENT =~ /^prod-.*/
      - $DL_ANSIBLE_DEPLOYMENT_TYPE == "configure-system" && $DL_DEPLOYMENT =~ /^prod-.*/

...
